package betterwithmods.common.blocks;

import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import javax.annotation.Nullable;
import java.util.List;

/**
 * @author mrebhan
 */

public class BlockPlatform extends BWMBlock {

    public BlockPlatform() {
        super(Material.field_151575_d);
        this.func_149711_c(2F);
        this.func_149672_a(SoundType.field_185848_a);
    }

    @Override
    public boolean isLadder(IBlockState state, IBlockAccess world, BlockPos pos, EntityLivingBase entity) {
        return true;
    }

    @Override
    public boolean isSideSolid(IBlockState base_state, IBlockAccess world, BlockPos pos, EnumFacing side) {
        return true;
    }

    @Override
    public boolean isNormalCube(IBlockState state, IBlockAccess world, BlockPos pos) {
        return false;
    }

    @Override
    public boolean func_149730_j(IBlockState state) {
        return false;
    }

    @Override
    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    @Override
    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @Override
    public boolean func_176225_a(IBlockState blockState, IBlockAccess world, BlockPos pos, EnumFacing side) {
        if (blockState.func_177230_c() == this) {
            IBlockState state2 = world.func_180495_p(pos.func_177972_a(side));
            return this.equals(state2.func_177230_c());
        }
        return super.func_176225_a(blockState, world, pos, side);
    }

    @Override
    public void func_185477_a(IBlockState state, World worldIn, BlockPos pos, AxisAlignedBB entityBox, List<AxisAlignedBB> collidingBoxes, @Nullable Entity entityIn, boolean p_185477_7_) {
        func_185492_a(pos, entityBox, collidingBoxes, new AxisAlignedBB(.0625f, 0, .0625f, .9375f, 1, .9375f));
    }

    @Override
    public void func_180634_a(World worldIn, BlockPos pos, IBlockState state, Entity entityIn) {
        super.func_180634_a(worldIn, pos, state, entityIn);
        if (entityIn instanceof EntityLivingBase && !((EntityLivingBase) entityIn).func_70617_f_() && isLadder(state, worldIn, pos, (EntityLivingBase) entityIn)) {
            float f5 = 0.15F;
            if (entityIn.field_70159_w < -f5)
                entityIn.field_70159_w = -f5;
            if (entityIn.field_70159_w > f5)
                entityIn.field_70159_w = f5;
            if (entityIn.field_70179_y < -f5)
                entityIn.field_70179_y = -f5;
            if (entityIn.field_70179_y > f5)
                entityIn.field_70179_y = f5;

            entityIn.field_70143_R = 0.0F;
            if (entityIn.field_70181_x < -0.15D)
                entityIn.field_70181_x = -0.15D;

            if (entityIn.field_70181_x < 0 && entityIn instanceof EntityPlayer && entityIn.func_70093_af()) {
                entityIn.field_70181_x = .05;
                return;
            }
            if (entityIn.field_70123_F)
                entityIn.field_70181_x = .2;
        }
    }

    @Override
    public BlockRenderLayer func_180664_k() {
        return BlockRenderLayer.CUTOUT;
    }



}
