package betterwithmods.common.blocks;

import betterwithmods.common.BWMBlocks;
import betterwithmods.util.DirUtils;
import betterwithmods.util.InvUtils;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

/**
 * Created by tyler on 5/17/17.
 */
public class BlockStake extends BWMBlock {


    public BlockStake() {
        super(Material.field_151575_d);
    }

    @Override
    public IBlockState getStateForPlacement(World world, BlockPos pos, EnumFacing facing, float hitX, float hitY, float hitZ, int meta, EntityLivingBase placer, EnumHand hand) {
        return func_176223_P().func_177226_a(DirUtils.FACING, facing.func_176734_d());
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, DirUtils.FACING, DirUtils.UP, DirUtils.DOWN, DirUtils.NORTH, DirUtils.SOUTH, DirUtils.WEST, DirUtils.EAST);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(DirUtils.FACING).func_176745_a();
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        return func_176223_P().func_177226_a(DirUtils.FACING, EnumFacing.func_82600_a(meta));
    }


    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @Override
    public boolean func_180639_a(World worldIn, BlockPos pos, IBlockState state, EntityPlayer playerIn, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        ItemStack stack = playerIn.func_184614_ca();
        if (side != state.func_177229_b(DirUtils.FACING) && stack.func_77969_a(new ItemStack(Items.field_151007_F)))
            return placeString(worldIn, pos, side.func_176734_d(), stack);
        return false;
    }

    public boolean placeString(World world, BlockPos pos, EnumFacing facing, ItemStack stack) {
        int count = stack.func_190916_E();
        int build = -1;
        for (int i = 1; i <= 64; i++) {
            if (world.func_180495_p(pos.func_177967_a(facing, i)).func_177230_c() instanceof BlockStake) {
                build = i;
                break;
            }
        }
        if (build > -1 && count >= (build - 1)) {
            stack.func_190918_g(build);
            for (int i = 1; i < build; i++) {
                world.func_175656_a(pos.func_177967_a(facing, i), BWMBlocks.STAKE_STRING.func_176223_P());
            }
            return true;
        }
        return false;
    }


    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos) {
        switch (state.func_177229_b(DirUtils.FACING)) {

            default:
                return new AxisAlignedBB(6 / 16f, 0, 6 / 16f, 10f / 16, 12f / 16f, 10f / 16f);
            case UP:
                return new AxisAlignedBB(6 / 16f, 4 / 16f, 6 / 16f, 10f / 16, 1, 10f / 16f);
            case NORTH:
                return new AxisAlignedBB(6 / 16f, 6 / 16f, 12f / 16f, 10f / 16f, 10f / 16, 0);
            case SOUTH:
                return new AxisAlignedBB(6 / 16f, 6 / 16f, 4f / 16f, 10f / 16f, 10f / 16, 1);
            case WEST:
                return new AxisAlignedBB(12f / 16f, 6 / 16f, 6 / 16f, 0, 10f / 16, 10f / 16f);
            case EAST:
                return new AxisAlignedBB(4f / 16f, 6 / 16f, 6 / 16f, 1, 10f / 16, 10f / 16f);

        }
    }


    @Override
    public IBlockState func_176221_a(IBlockState state, IBlockAccess worldIn, BlockPos pos) {
        IBlockState newState = state;
        for (int i = 0; i < EnumFacing.field_82609_l.length; i++) {
            newState = newState.func_177226_a(DirUtils.DIR_PROP[i], getDirection(worldIn, pos, EnumFacing.func_82600_a(i).func_176734_d()));
        }
        return newState;
    }

    public static boolean getDirection(IBlockAccess world, BlockPos pos, EnumFacing facing) {
        Block block = world.func_180495_p(pos.func_177972_a(facing)).func_177230_c();
        return block instanceof BlockStakeString || block instanceof BlockStake;
    }

    @Override
    public BlockRenderLayer func_180664_k() {
        return BlockRenderLayer.CUTOUT_MIPPED;
    }

    @Override
    public void func_180663_b(World worldIn, BlockPos pos, IBlockState state) {
        worldIn.func_175685_c(pos,this,true);
        for(EnumFacing facing: EnumFacing.field_82609_l) {
            if(getDirection(worldIn,pos,facing)) {
                InvUtils.ejectStackWithOffset(worldIn, pos.func_177972_a(facing), func_185473_a(worldIn, pos, state));
                worldIn.func_175698_g(pos.func_177972_a(facing));
            }
        }
        super.func_180663_b(worldIn, pos, state);
    }
}
