package betterwithmods.common.blocks.mechanical.tile;

import betterwithmods.common.blocks.mini.IDamageDropped;
import betterwithmods.common.damagesource.BWDamageSource;
import betterwithmods.common.registry.blockmeta.managers.SawManager;
import betterwithmods.util.DirUtils;
import betterwithmods.util.InvUtils;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.WorldServer;

import java.util.List;
import java.util.Random;

public class TileSteelSaw extends TileAxleMachine {
    @Override
    public AxisAlignedBB getRenderBoundingBox() {
        return super.getRenderBoundingBox();
    }

    @Override
    public void func_73660_a() {
        if (getPower() > 0 && !field_145850_b.field_72995_K && field_145850_b.func_82737_E() % 10 == 0) {
            IBlockState state = field_145850_b.func_180495_p(field_174879_c);

            AxisAlignedBB box = new AxisAlignedBB(field_174879_c.func_177958_n()+0.5f,field_174879_c.func_177956_o()+0.5f,field_174879_c.func_177952_p()+0.5f,field_174879_c.func_177958_n()+0.5f,field_174879_c.func_177956_o()+0.5f,field_174879_c.func_177952_p()+0.5f);
            switch (state.func_177229_b(DirUtils.AXIS)) {

                case X:
                    box = box.func_72314_b(0, 1, 1);
                    break;
                case Y:
                    box = box.func_72314_b(1, 0, 1);
                    break;
                case Z:
                    box = box.func_72314_b(1, 1, 0);
                    break;
            }
            List<EntityLivingBase> entities = field_145850_b.func_72872_a(EntityLivingBase.class, box);
            entities.forEach(e -> e.func_70097_a(BWDamageSource.saw, 10));

            Iterable<BlockPos> positions = BlockPos.PooledMutableBlockPos.func_191532_a((int) box.field_72340_a, (int) box.field_72338_b, (int) box.field_72339_c, (int) box.field_72336_d, (int) box.field_72337_e, (int) box.field_72334_f);
            for (BlockPos pos : positions) {
                saw(field_145850_b, pos, field_145850_b.field_73012_v);
            }

        }
    }

    @Override
    public byte getMaximumSignal() {
        return 5;
    }

    private void saw(World world, BlockPos pos, Random rand) {
        if (world.field_72995_K || !(world instanceof WorldServer))
            return;
        if (world.func_175623_d(pos))
            return;
        IBlockState state = world.func_180495_p(pos);
        Block block = state.func_177230_c();
        int harvestMeta = block.func_180651_a(state);
        if (block instanceof IDamageDropped)
            harvestMeta = ((IDamageDropped) block).damageDropped(state, world, pos);

        if (SawManager.WOOD_SAW.contains(block, harvestMeta)) {
            List<ItemStack> products = SawManager.WOOD_SAW.getProducts(block, harvestMeta);
            world.func_175698_g(pos);
            if (!products.isEmpty())
                InvUtils.ejectStackWithOffset(world, pos, products);
            world.func_184133_a(null, pos, SoundEvents.field_187782_ds, SoundCategory.BLOCKS, 1.5F + rand.nextFloat() * 0.1F, 2.0F + rand.nextFloat() * 0.1F);
        } else if (SawManager.STEEL_SAW.contains(block, harvestMeta)) {
            List<ItemStack> products = SawManager.STEEL_SAW.getProducts(block, harvestMeta);
            world.func_175698_g(pos);
            if (!products.isEmpty())
                InvUtils.ejectStackWithOffset(world, pos, products);
            world.func_184133_a(null, pos, SoundEvents.field_187782_ds, SoundCategory.BLOCKS, 1.5F + rand.nextFloat() * 0.1F, 2.0F + rand.nextFloat() * 0.1F);
        }
    }
}
